%% Testing generalization perfroamnce of trained perceptron
 perceptronTrain; 
 letterMatrix=rIn; 
 for nflip = 1:80;    
    dist1=[]; dist2=[]; 
    for trial=1:10; 
       rIn=abs(letterMatrix-randomFlipMatrix(nflip)); 
       % Threshold output function
       rOut1=(wOut*rIn)>0;
       nerror=0; 
       for j=1:26; nerror=nerror+(sum(rDes(:,j)~=rOut1(:,j))>0); end 
       dist1=[dist1,nerror];
       % Max output function
       [v,i]=max(wOut*rIn);
       rOut2=zeros(26); for j=1:26; rOut2(i(j),j)=1; end
       dist2=[dist2,0.5*sum(sum(rDes~=rOut2))];
    end
    meanDist1(nflip)=mean(dist1); stdDist1(nflip)=std(dist1);
    meanDist2(nflip)=mean(dist2); stdDist2(nflip)=std(dist2);
 end
 figure; hold on;
 errorbar((1:80)/156,meanDist1,stdDist1,':')
 errorbar((1:80)/156,meanDist2,stdDist2,'r')
 xlabel('Fraction of flipped bits')
 ylabel('Average number of wrong letters')